package de.hdm_stuttgart.mi.marking;



/**
 * 
 * 
 */
public class Marks {
  

    /**
     * @param args Unused
     */
    public static void main( String[] args ) {
        System.out.println( "Hello World!" );
        
    }
        
    /**
     * Gathering frequencies of integer values. Consider:
     * 
     * {-3, 4 , 2, -2, 4, -3, 2, 4}
     * 
     * The resulting frequencies are:
     * 
     * Value | frequency
     * ------+---------
     *    -3 | 2
     *    -2 | 1
     *    -1 | 0
     *     0 | 0
     *     1 | 0
     *     2 | 2
     *     3 | 0
     *     4 | 3
     *     
     * Thus the resulting array will be {2, 1, 0, 0, 0, 2, 0, 3}
     * 
     * 
     * @param values
     *  A non-empty list possibly containing duplicates.
     * @return
     *  An array containing the input values' frequencies. The array index 0 corresponds to the smallest input value(s). 
     */
    static public int[] getFrequencies(final int[] values) {
      
      // Step 1: We need to find the minimum and maximum value
   
      // Starting from the "worst" assumption.
      //
      int maxValue = Integer.MIN_VALUE,
          minValue = Integer.MAX_VALUE;
      
      for (final int v: values) {
        if (maxValue < v) {
          maxValue = v;
        }
        if (v < minValue) {
          minValue = v;
        }
      }
      
      // Now we need an array of appropriate size to collect the desired frequencies 
      
      final int[] ret = new int[maxValue - minValue + 1];
      
      // Collect the values' frequencies
      for (final int v: values) {
        ret[v - minValue]++;
      }
      return ret;
    }
    
}
